local require = GLOBAL.require
local resolvefilepath = GLOBAL.resolvefilepath
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local STRINGS = GLOBAL.STRINGS
local ACTIONS = GLOBAL.ACTIONS
local TECH = GLOBAL.TECH
local containers = require("containers")
local TheNet = GLOBAL.TheNet
local next = GLOBAL.next
local ThePlayer = GLOBAL.ThePlayer
local IsServer = GLOBAL.TheNet:GetIsServer()
local TheInput = GLOBAL.TheInput

--[[]]
modimport("yasuo_key/yasuo_key.lua")

PrefabFiles = {
  "yasuo",
        "woodsword",
        "trialsword",
        "bloodsword",
        "galesword",
        "galesword_low",
        "galecloak",
        "galegift",
        "hudun",
        "fengqiang",
        "yasuo_huanyuan",
        "yasuo_fangyu",
        "yasuo_gongji",
}



Assets = {
  Asset( "IMAGE", "images/saveslot_portraits/yasuo.tex" ),
  Asset( "ATLAS", "images/saveslot_portraits/yasuo.xml" ),

  Asset( "IMAGE", "images/selectscreen_portraits/yasuo.tex" ),
  Asset( "ATLAS", "images/selectscreen_portraits/yasuo.xml" ),

  Asset( "IMAGE", "bigportraits/yasuo.tex" ),
  Asset( "ATLAS", "bigportraits/yasuo.xml" ),
    
  Asset( "IMAGE", "images/map_icons/yasuo.tex" ),
  Asset( "ATLAS", "images/map_icons/yasuo.xml" ),
    	
  Asset( "IMAGE", "images/avatars/avatar_yasuo.tex" ),
  Asset( "ATLAS", "images/avatars/avatar_yasuo.xml" ),
  Asset( "IMAGE", "images/avatars/avatar_ghost_yasuo.tex" ),
  Asset( "ATLAS", "images/avatars/avatar_ghost_yasuo.xml" ),

  Asset("IMAGE", "images/inventoryimages/woodsword.tex"),
	Asset("ATLAS", "images/inventoryimages/woodsword.xml"),

	Asset("IMAGE", "images/inventoryimages/trialsword.tex"),
	Asset("ATLAS", "images/inventoryimages/trialsword.xml"),

  Asset("IMAGE", "images/inventoryimages/bloodsword.tex"),
  Asset("ATLAS", "images/inventoryimages/bloodsword.xml"),

	Asset("IMAGE", "images/inventoryimages/galesword.tex"),
	Asset("ATLAS", "images/inventoryimages/galesword.xml"),

  Asset("IMAGE", "images/inventoryimages/galesword_low.tex"),
  Asset("ATLAS", "images/inventoryimages/galesword_low.xml"),

  Asset("IMAGE", "images/inventoryimages/galecloak.tex"),
  Asset("ATLAS", "images/inventoryimages/galecloak.xml"),

  Asset("IMAGE", "images/inventoryimages/galegift.tex"),
  Asset("ATLAS", "images/inventoryimages/galegift.xml"),
}


GLOBAL.STRINGS.NAMES.WOODSWORD = "WoodSword"
GLOBAL.STRINGS.RECIPE_DESC.WOODSWORD = "A legendary sword!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.WOODSWORD = "WoodSword"

GLOBAL.STRINGS.NAMES.TRIALSWORD = "TrialSword"
GLOBAL.STRINGS.RECIPE_DESC.TRIALSWORD = "An mysterious sword"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.TRIALSWORD = "TrialSword"

GLOBAL.STRINGS.NAMES.BLOODSWORD = "Bloodsword"
GLOBAL.STRINGS.RECIPE_DESC.BLOODSWORD = "My sword is Hungry!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.BLOODSWORD = "Bloodsword"

GLOBAL.STRINGS.NAMES.GALESWORD = "Galesword"
GLOBAL.STRINGS.RECIPE_DESC.GALESWORD = "Gale can destroy anything!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALESWORD = "Galesword"

GLOBAL.STRINGS.NAMES.GALESWORD_LOW = "Galesword_Low"
GLOBAL.STRINGS.RECIPE_DESC.GALESWORD_LOW = "Can't destroy structure!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALESWORD_LOW = "Galesword_Low"

GLOBAL.STRINGS.NAMES.GALECLOAK = "Galecloak"
GLOBAL.STRINGS.RECIPE_DESC.GALECLOAK = "Invisible Wind"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALECLOAK = "Galecloak"

GLOBAL.STRINGS.NAMES.GALEGIFT = "Galegift"
GLOBAL.STRINGS.RECIPE_DESC.GALEGIFT = "Wind Protection"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALEGIFT = "Galegift"


STRINGS.CHARACTER_TITLES.yasuo = "Yasuo"
STRINGS.CHARACTER_NAMES.yasuo = "Yasuo"
STRINGS.CHARACTER_DESCRIPTIONS.yasuo = "*Fast-but-easy-to-die \n*An-amazing-sword\n*Sword-can-be-hided"
STRINGS.CHARACTER_QUOTES.yasuo = "\"Death is like the wind; always by my side\""


-- The default responses of examining the character
STRINGS.CHARACTERS.GENERIC.DESCRIBE.YASUO = 
{
	GENERIC = "Haha",
	ATTACKER = "Hahaha",
	MURDERER = "Hahahaha",
	REVIVER = "Hahahahaha",
	GHOST = "Er...",
}


local woodsword_recipe = AddRecipe("woodsword", 
{GLOBAL.Ingredient("log", 3)}, 
RECIPETABS.WAR, TECH.NONE, 
nil, nil, nil, nil, nil, 
"images/inventoryimages/woodsword.xml", "woodsword.tex")

local woodsword = Ingredient( "woodsword", 1)
woodsword.atlas = "images/inventoryimages/woodsword.xml"

local bloodsword_recipe = AddRecipe("bloodsword", 
{woodsword, GLOBAL.Ingredient("monstermeat", 3)}, 
RECIPETABS.WAR, TECH.NONE, 
nil, nil, nil, nil, nil, 
"images/inventoryimages/bloodsword.xml", "bloodsword.tex")

local trialsword_recipe = AddRecipe("trialsword", 
{woodsword, GLOBAL.Ingredient("goldnugget", 3)}, 
RECIPETABS.WAR, TECH.NONE, 
nil, nil, nil, nil, nil, 
"images/inventoryimages/trialsword.xml", "trialsword.tex")

local trialsword = Ingredient( "trialsword", 1)
    trialsword.atlas = "images/inventoryimages/trialsword.xml"

local galesword_low_recipe = AddRecipe("galesword_low", 
{trialsword, GLOBAL.Ingredient("livinglog", 3)}, 
RECIPETABS.WAR, TECH.NONE, 
nil, nil, nil, nil, nil, 
"images/inventoryimages/galesword_low.xml", "galesword_low.tex")

local galesword_low = Ingredient( "galesword_low", 1)
    galesword_low.atlas = "images/inventoryimages/galesword_low.xml"

local galesword_recipe = AddRecipe("galesword", 
{galesword_low, GLOBAL.Ingredient("nightmarefuel", 3)}, 
RECIPETABS.WAR, TECH.NONE, 
nil, nil, nil, nil, nil, 
"images/inventoryimages/galesword.xml", "galesword.tex")

local galecloak_recipe = AddRecipe("galecloak", 
{GLOBAL.Ingredient("pigskin", 1), GLOBAL.Ingredient("rope", 3), GLOBAL.Ingredient("livinglog", 3)}, 
RECIPETABS.WAR, TECH.NONE, 
nil, nil, nil, nil, nil, 
"images/inventoryimages/galecloak.xml", "galecloak.tex")

local galegift_recipe = AddRecipe("galegift", 
{GLOBAL.Ingredient("flowerhat", 1), GLOBAL.Ingredient("livinglog", 3)}, 
RECIPETABS.WAR, TECH.NONE, 
nil, nil, nil, nil, nil, 
"images/inventoryimages/galegift.xml", "galegift.tex")


function AddMap(inst)
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( inst.prefab .. ".tex" )
end
AddPrefabPostInit("woodsword", AddMap)
AddMinimapAtlas("images/inventoryimages/woodsword.xml")
AddPrefabPostInit("trialsword", AddMap)
AddMinimapAtlas("images/inventoryimages/trialsword.xml")
AddPrefabPostInit("bloodsword", AddMap)
AddMinimapAtlas("images/inventoryimages/bloodsword.xml")
AddPrefabPostInit("galesword", AddMap)
AddMinimapAtlas("images/inventoryimages/galesword.xml")
AddPrefabPostInit("galesword_low", AddMap)
AddMinimapAtlas("images/inventoryimages/galesword_low.xml")
AddPrefabPostInit("galecloak", AddMap)
AddMinimapAtlas("images/inventoryimages/galecloak.xml")
AddPrefabPostInit("galegift", AddMap)
AddMinimapAtlas("images/inventoryimages/galegift.xml")

local oldwidgetsetup = containers.widgetsetup
containers.widgetsetup = function(container, prefab)
if not prefab and container.inst.prefab == "galecloak" then
prefab = "backpack" end
oldwidgetsetup(container, prefab)
end

table.insert(GLOBAL.CHARACTER_GENDERS.MALE, "yasuo")
AddMinimapAtlas("images/map_icons/yasuo.xml")
AddModCharacter("yasuo")

local attack_name = {"bee", "killerbee", "flies", "mosquito", "frog", "beefalo", "lightninggoat", "pigman", "pigguard",
 "bunnyman", "merm", "spider_hider", "spider_spitter", "spider", "spider_warrior", "spiderqueen", "spider_dropper", "hound",
 "firehound", "icehound", "tentacle", "leif", "leif_sparse", "walrus", "teenbird", "tallbird", "koalefant_summer",
 "koalefant_winDter", "penguin", "slurtle", "snurtle", "bat", "rocky", "monkey", "slurper", "buzzard", "knight", "bishop",
 "rook", "crawlinghorror", "terrorbeak", "deerclops", "minotaur", "worm", "abigail", "ghost", "shadowwaxwell", "krampus",
 "glommer", "lureplant", "eyeplant", "moose", "mossling", "dragonfly", "warg", "bearger", "birchnutdrake"
}

--每20s可以免疫一次伤害
local cooldowntime = 20
local cooldown
local function onattack(inst, data)
    if  data.target.prefab == "yasuo"
    and not cooldown then
    cooldown = true
    inst.components.combat:SetDefaultDamage(0)

    local hudun = GLOBAL.SpawnPrefab("hudun")
    hudun.entity:SetParent(data.target.entity)
    hudun.Transform:SetPosition(0, 0, 0)
    hudun.Transform:SetScale(2, 2, 2)
    hudun.AnimState:PlayAnimation("idle_hd",true)
    data.target:DoTaskInTime( 0.6, function() 
      hudun.kill_fx(hudun) 
        if inst.task then inst.task:Cancel() inst.task = nil end 
    end)

    local light = data.target.entity:AddLight()
    light:SetFalloff(0.8)
    light:SetIntensity(0.5)
    light:SetRadius(0.8)
    light:SetColour(255/255, 255/255, 255/255)
    light:Enable(true)

    data.target:DoTaskInTime( cooldowntime, function() 
      cooldown = false
      light:Enable(false)
      end)

    else
    inst.components.combat:SetDefaultDamage(inst.components.combat.tempdamage)
    end
end
--技能基础函数
local function dodge(inst)
    if  inst.components.combat then
        inst.components.combat.tempdamage = inst.components.combat.defaultdamage
        inst:ListenForEvent("onattackother", onattack)
    end
end

--为列表上的生物攻击变为0

for k,v in pairs(attack_name) do
    AddPrefabPostInit (v, dodge)
end
